package br.exemplogoogleplus.thiengo.adapter;

import java.util.List;

import br.exemplogoogleplus.thiengo.MainActivity;
import br.exemplogoogleplus.thiengo.R;
import br.exemplogoogleplus.thiengo.domain.User;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

public class UsersAdapter extends BaseAdapter {
	private Context context;
	private List<User> list;
	private LayoutInflater inflater;
	
	public UsersAdapter(Context context, List<User> list){
		this.context = context;
		this.list = list;
		inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}
	
	@Override
	public int getCount() {
		return list.size();
	}

	@Override
	public Object getItem(int position) {
		return list.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		User u = list.get(position);
		ViewHolder holder;
		
		if(convertView == null){
			convertView = inflater.inflate(R.layout.item,  null);
			holder = new ViewHolder();
			convertView.setTag(holder);
			
			holder.ivImg = (ImageView) convertView.findViewById(R.id.ivImg);
			holder.pbLoad = (ProgressBar) convertView.findViewById(R.id.pbLoad);
			holder.tvId = (TextView) convertView.findViewById(R.id.tvId);
			holder.tvName = (TextView) convertView.findViewById(R.id.tvName);
		}
		else{
			holder = (ViewHolder) convertView.getTag();
		}
		
		if(u.getUrl() != null){
			MainActivity.loadImage(context, holder.ivImg, holder.pbLoad, u.getUrl());
		}
		holder.tvId.setText(u.getId());
		holder.tvName.setText(u.getName());
		
		return convertView;
	}
	
	
	private static class ViewHolder{
		ImageView ivImg;
		ProgressBar pbLoad;
		TextView tvName;
		TextView tvId;
	}
}
